#include "fatapp.h"
#include "stdio.h"						 //printfļ
#include "string.h"						 //ַļ
#include "ili9328.h"

BYTE Buffer[512];


/********************************************************/
/* ܣдļ                                     */
/* ڲfileName:ҪдļҪļ    */
/*           buffer: Ҫдݴ               */
/* ڲ0ɹ    1ʧ                         */
/********************************************************/
FRESULT FileWrite(const TCHAR *fileName,const uint8_t *buffer)
{
	FATFS fs;           // ļϵͳ
    FIL file;           // ļ
	UINT  bw;           // ֽ

    f_mount(0, &fs);	// ļϵͳ
	// ļдݣûиļһΪ*fileNameļд
    if(f_open(&file, fileName, FA_CREATE_ALWAYS|FA_WRITE)) 
    {
		return FR_NO_FILE;
    }
	else
	{
		do
		{
			if(f_write(&file, buffer, 512, &bw))
			{
				return FR_NO_FILE;
			}
		} while (bw < 512);  // жǷ(bw = 512ʾд)
   	 	f_close(&file);      // رļf_openɶԳ
	}
    f_mount(0, 0);	  //жļϵͳ

    return FR_OK;
}

/********************************************************/
/* ܣļ                                     */
/* ڲfileName:Ҫȡļ                    */
/*           buf: Ҫȡݴ                  */
/* ڲ0ɹ    1ʧ                         */
/********************************************************/
FRESULT FileRead(const TCHAR *fileName, uint8_t *buf)
{
	FATFS fs;              // һļϵͳ
    FIL file;              // ݴļ
	UINT  br;              // ֽڼ
	FRESULT res;		   // 洢ִн

    f_mount(0,&fs);	   // ļϵͳ

	res = f_open(&file, fileName, FA_OPEN_EXISTING|FA_READ); // ļ
	
    if(res != FR_OK)  // ûȷļ
    {
		return res;	  // ش󱨸
    }
	else			  // ļ
	{
		do
		{
		    f_read(&file, buf, 512, &br);// ȡļݣÿ512ֽ
		}while(br); // br = 0 ʾ
	}
	
   	f_close(&file);      // رļf_openɶԳ
// 	GPIO1->DATA &= ~(1<<10);
    f_mount(0,0);		 // жļϵͳ
	
    return FR_OK;
}

/************************************************/
/* ƣļļɨ               */
/* ڲ*path·                        */
/* ڲļ                           */
/* ˵    ֳ֧ļ
             ˵ĵļ֮⣬ÿһ
			 ļļʹ洢ʾ
			 FileNflagУ洢50ļ
			 50ļԣӣ
			 LPC1114ڴ֮޸ġ          */
/************************************************/
char FileN[50][50];	// ļ洢
char type[8][20]={"bmp","txt","exe","pdf","doc","xls","zip","rar"};	// ļͶ
char flag[50]; // ļʹ洢 

BYTE FileScan(BYTE *path)
{
	FATFS fs;      // һļϵͳ         
    FRESULT res;   // 洢ִн
    FILINFO finfo;  // 洢ļ״̬Ϣ
    DIR dir;	   // ݴ·
    TCHAR *fn;	   // ݴļ
	INT fileNum = 0;  // ʼļ
	INT size;   // ļ
#if _USE_LFN
  	static char lfn[_MAX_LFN * (_DF1S ? 2 : 1) + 1];
  	finfo.lfname=lfn;
  	finfo.lfsize=sizeof(lfn);
#endif
    f_mount(0, &fs);    // ļϵͳ
    res = f_opendir(&dir, (const TCHAR *)path);    // ·Ŀ¼
    if (res == FR_OK)	// ·򿪳ɹ
    {
    	while (f_readdir(&dir, &finfo) == FR_OK)  //ѭȡĿ¼ֱ 
    	{ 			
			#if _USE_LFN   // ļ
			  fn = *finfo.lfname ? finfo.lfname : finfo.fname;
			#else          // ļ
			  fn = finfo.fname;
			#endif			
			if((finfo.fattrib & AM_DIR)||(finfo.fattrib & AM_ARC))  //ļ(AM_DIR)ļ(AM_ARC) 
			{ 
				if(!fn[0])break;	//꣬ѭ			    
				size=strlen(fn);	//ļ
				if(finfo.fattrib & AM_DIR)flag[fileNum]=0;	//жļУ				  	
				if(finfo.fattrib & AM_ARC)	 //жļ
				{
					if(strcasecmp(&fn[size-3],type[0])==0)flag[fileNum]=1;//ٴжbmpͼƬ																			 //ǰļ־1
					else if(strcasecmp(&fn[size-3],type[1])==0)flag[fileNum]=2;//ıĵ
					else if(strcasecmp(&fn[size-3],type[2])==0)flag[fileNum]=3;//exeļ
					else if(strcasecmp(&fn[size-3],type[3])==0)flag[fileNum]=4;//pdfļ
					else if(strcasecmp(&fn[size-3],type[4])==0)flag[fileNum]=5;//wordıĵ
					else if(strcasecmp(&fn[size-3],type[5])==0)flag[fileNum]=6;//execlļ
					else if(strcasecmp(&fn[size-3],type[6])==0)flag[fileNum]=7;//zipļ
					else if(strcasecmp(&fn[size-3],type[7])==0)flag[fileNum]=7;//rarļ
					else flag[fileNum] = 88;																				 //ǰļ־2
				}  	   
				strcpy(FileN[fileNum],fn);	//ļƸFileN鱣
				fileNum++;    //һfileNumΪļ
			}			 
    	}  
    }

    f_mount(0, 0);	 // жļϵͳ
    return fileNum;	 // ļ
}



/**************************************************/
/* ܣȡBMPͼƬͷļϢ              */
/* ڲbufݴ滺                        */
/**************************************************/
BMP_HEADER TFTBmpGetHeadInfo(uint8_t *buf)
{
	BMP_HEADER bmpHead;

	bmpHead.bfType = (buf[0] << 8) + buf[1];		   // BM
	bmpHead.bfSize	= (buf[5]<<24) + (buf[4]<<16) + (buf[3]<<8) + buf[2];     // ļС
	bmpHead.biWidth = (buf[21]<<24) + (buf[20]<<16) + (buf[19]<<8) + buf[18]; // ͼ
	bmpHead.biHeight = (buf[25]<<24) + (buf[24]<<16) + (buf[23]<<8) + buf[22];// ͼ߶
	bmpHead.biBitCount = (buf[29] << 8) + buf[28];	   // ÿصλɫλͼΪ256ɫΪ816bitΪ16 24bitΪ24

	return bmpHead;
}
/**************************************************/
/* ܣʾBMPͼƬ                          */
/* ڲx,y:                             */
/*           *bmpName:bmpͼƬƣԴ·   */
/**************************************************/
uint8_t TFTBmpDisplay(uint8_t *bmpName,uint16_t x,uint16_t y)
{
    FATFS fs;         // ļϵͳ
    FIL file;         // ļ
	UINT  br;         // ֽڼ
	FRESULT res;      // ֵϢ
	BMP_HEADER bmpHead;	    // ͷϢ
	uint16_t i;

    f_mount(0, &fs);  // ļϵͳ
	res = f_open(&file, (const TCHAR *)bmpName, FA_OPEN_EXISTING|FA_READ); // BMPļȡfile
	if(res != FR_OK)
    {
		return res;
    }
	else
	{
	    res = f_read(&file, Buffer, 54, &br);	 // ȡͷļϢ
		if(res != FR_OK)
	    {
			return res;	   // شʾ
	    }
		else
		{
		    bmpHead = TFTBmpGetHeadInfo(Buffer); // ȡͷϢ

			if (bmpHead.bfType == 0x424D) // жǷΪBMPͼ
			{
				LCD_WR_REG_DATA(0x0003, 0x1010); // ¶ʾ
				LCD_XYRAM(x, y, x+bmpHead.biWidth-1, y+bmpHead.biHeight-1);
				LCD_WR_REG_DATA(0x0020,x);//Xλ
			    LCD_WR_REG_DATA(0x0021,y+bmpHead.biHeight-1);//Yλ(ע⣺¶ʾʱyӦ±ߵֵ)
			    LCD_WR_REG(0x0022);	//ָRAMĴ׼дݵRAM
			    while(1)
				{
		            res = f_read(&file, Buffer, 240, &br);  //ȡ240
					if(res||br==0)   																					//
	                break;
		          	for(i=0;i<80;i++)
					{	
						// TFTʾһصɫ			
						LCD_WR_DATA(((Buffer[i*3+2]/8)<<11 | (Buffer[i*3+1]/4)<<5 |(Buffer[i*3]/8)));
					}
				}
				LCD_WR_REG_DATA(0x0003, 0x1030); // ָʾ
				LCD_XYRAM(0, 0, 239, 319);       // ָGRAM
			}
		}
	}

   	f_close(&file);      // رļf_openɶԳ
    f_mount(0, 0);  	 // жļϵͳ

	return FR_OK;	   // سɹ־
}

// /*********************************************/
// /* ܣʾļĺӢģ        */
// /* ڲx,y:                        */
// /*           *p:ַ                       */
// /*********************************************/
// void FileNameShow(uint16_t x,uint16_t y,uint8_t *p)
// {         
//     while(*p!='\0')	// ûн
//     {       
//         if(*p>0x80)//
// 		{
// 			LCD_Show_hz(x, y, p);
// 			x+=16;
// 			if(x>224)return;
// 			p+=2;
// 		}
// 		else	   //Ӣ
// 		{
// 			LCD_ShowChar(x,y,*p);
// 			if(x>224)return;
// 			x+=8;
// 			p++;
// 		}
//     }  
// }
