#include "stm32f0xx.h"
#include "system.h"
	 
//ʹucos,ͷļ.
#if SYSTEM_SUPPORT_UCOS
#include "includes.h"					//ucos ʹ	  
#endif
	 
static u8  fac_us=0;//usʱ
static u16 fac_ms=0;//msʱ

#ifdef OS_CRITICAL_METHOD 	//OS_CRITICAL_METHOD,˵ʹucosII.
//systickжϷ,ʹucosʱõ
void SysTick_Handler(void)
{				   
    OSIntEnter();		//ж
    OSTimeTick();       //ucosʱӷ               
    OSIntExit();        //лж
}
#endif

void Delay_init()	 
{

#ifdef OS_CRITICAL_METHOD 	//OS_CRITICAL_METHOD,˵ʹucosII.
	u32 reload;
#endif
	fac_us=SystemCoreClock/32000000;	//ΪϵͳʱӶƵ  
	 
#ifdef OS_CRITICAL_METHOD 	//OS_CRITICAL_METHOD,˵ʹucosII.
	reload=SystemCoreClock/32000000;		//ÿӵļ λΪK	   
	reload*=1000000/OS_TICKS_PER_SEC;//OS_TICKS_PER_SEC趨ʱ
							//reloadΪ24λĴ,ֵ:16777216,72M,Լ1.86s	
	fac_ms=1000/OS_TICKS_PER_SEC;//ucosʱٵλ	   
	SysTick->CTRL|=SysTick_CTRL_TICKINT_Msk; //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL = (1<<SYSTICK_TICKINT); //SYSTICKж
	SysTick->LOAD=reload; 	//ÿ1/OS_TICKS_PER_SECжһ
	SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk;  //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL = (1<<SYSTICK_CLKSOURCE)|(1<<SYSTICK_ENABLE); //SYSTICK    
#else
	fac_ms=(u16)fac_us*1000;//ucos,ÿmsҪsystickʱ   
#endif
}								    

#ifdef OS_CRITICAL_METHOD	//ʹucos
//ʱnus
//nusΪҪʱus.		    								   
void delay_us(u32 nus)
{		
	u32 ticks;
	u32 told,tnow,tcnt=0;
	u32 reload=SysTick->LOAD;	//LOADֵ	    	 
	ticks=nus*fac_us; 			//ҪĽ	  		 
	tcnt=0;
	told=SysTick->VAL;        	//սʱļֵ
	while(1)
	{
		tnow=SysTick->VAL;	
		if(tnow!=told)
		{	    
			if(tnow<told)tcnt+=told-tnow;//עһSYSTICKһݼļͿ.
			else tcnt+=reload-tnow+told;	    
			told=tnow;
			if(tcnt>=ticks)break;//ʱ䳬/Ҫӳٵʱ,˳.
		}  
	}; 									    
}
//ʱnms
//nms:Ҫʱms
void delay_ms(u16 nms)
{	
	if(OSRunning==TRUE)//osѾ	    
	{		  
		if(nms>=fac_ms)//ʱʱucosʱ 
		{
   			OSTimeDly(nms/fac_ms);//ucosʱ
		}
		nms%=fac_ms;				//ucosѾ޷ṩôСʱ,ͨʽʱ    
	}
	delay_us((u32)(nms*1000));	//ͨʽʱ,ʱucos޷.
}
#else//ucosʱ
//ʱnus
//nusΪҪʱus.		    								   
void delay_us(u32 nus)
{		
	u32 temp;	    	 
	SysTick->LOAD=nus*fac_us; //ʱ	  		 
	SysTick->VAL=0x00;        //ռ
	SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk; //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL = (1<<SYSTICK_CLKSOURCE)|(1<<SYSTICK_ENABLE); //жδ 	 
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));//ȴʱ䵽   
	SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;  //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL&=~(1<<SYSTICK_ENABLE);       //رռ
	SysTick->VAL =0X00;       //ռ	 
}
//ʱnms
//עnmsķΧ
//SysTick->LOADΪ24λĴ,,ʱΪ:
//nms<=0xffffff*8*1000/SYSCLK
//SYSCLKλΪHz,nmsλΪms
//72M,nms<=1864 
void delay_ms(u16 nms)
{	 		  	  
	u32 temp;		   
	SysTick->LOAD=(u32)nms*fac_ms;//ʱ(SysTick->LOADΪ24bit)
	SysTick->VAL =0x00;           //ռ
	SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk; //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL = (1<<SYSTICK_CLKSOURCE)|(1<<SYSTICK_ENABLE); //жδ 
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));//ȴʱ䵽   
	SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;  //ʹCMSIScor_cm0.hV3.02汾
	//SysTick->CTRL&=~(1<<SYSTICK_ENABLE);       //رռ
	SysTick->VAL =0X00;       //ռ	  	    
} 
#endif


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ĿǰUSART1USART2:8+1+0,Ӳ
//USART2ʺϵãUSARTLINģʽͽճʱжϺSTOPģʽ

u8  USART_RX_BUF[USART_REC_LEN]; //ջ,USART_REC_LENֽ.ĩֽΪз 
u16 USART_RX_STA=0;         		//״̬

//´,֧printf,Ҫѡuse MicroLIB
#if 1
#pragma import(__use_no_semihosting)             
//׼Ҫֺ֧                 
struct __FILE 
{ 
	int handle; 
}; 

FILE __stdout;       
//_sys_exit()Աʹðģʽ    
_sys_exit(int x) 
{ 
	x = x; 
} 
//ضfputc 
int fputc(int ch, FILE *f)
{      
  while((USART2->ISR&0X40)==0);  //ע⣬ǰUSART2
  USART2->TDR = (u8) ch;      
	return ch;
}
#endif 
 
 
void USART1_Init(u32 bound)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	NVIC_InitTypeDef NVIC_InitStructure;
	USART_InitTypeDef USART_InitStructure; 
	
	USART_DeInit(USART1);//ȸλ	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);  

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_1);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_1);

  GPIO_InitStruct.GPIO_Pin = GPIO_Pin_9 |GPIO_Pin_10  ;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStruct.GPIO_Speed =GPIO_Speed_Level_3;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
	//USART2 NVIC 
  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority = 3;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
	
	USART_InitStructure.USART_BaudRate = bound;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART1, &USART_InitStructure);

  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);//ж
  USART_Cmd(USART1, ENABLE);                    //ʹܴ 
}

void USART1_IRQHandler(void)  //1жϷ,лسеĲſɽ
{
	u8 Res;
#ifdef OS_TICKS_PER_SEC	 
	OSIntEnter();    
#endif
	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET) 
		{
		Res =USART_ReceiveData(USART1);
		
		if((USART_RX_STA&0x8000)==0)
			{
			if(USART_RX_STA&0x4000)
				{
				if(Res!=0x0a)USART_RX_STA=0;
				else USART_RX_STA|=0x8000;	
				}
			else
				{	
				if(Res==0x0d)USART_RX_STA|=0x4000;
				else
					{
					USART_RX_BUF[USART_RX_STA&0X3FFF]=Res ;
					USART_RX_STA++;
					if(USART_RX_STA>(USART_REC_LEN-1))USART_RX_STA=0;
					}		 
				}
			}   		 
     } 
#ifdef OS_TICKS_PER_SEC
	OSIntExit();  											 
#endif
} 

void USART2_Init(u32 bound)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	NVIC_InitTypeDef NVIC_InitStructure;
	USART_InitTypeDef USART_InitStructure; 
	
	USART_DeInit(USART2);//ȸλ	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);  

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_1);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_1);

  GPIO_InitStruct.GPIO_Pin = GPIO_Pin_2 |GPIO_Pin_3  ;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStruct.GPIO_Speed =GPIO_Speed_Level_3;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
	//USART2 NVIC 
  NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority = 3;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
	
	USART_InitStructure.USART_BaudRate = bound;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART2, &USART_InitStructure);

  USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);//ж
  USART_Cmd(USART2, ENABLE);                    //ʹܴ 
}

void USART2_IRQHandler(void)  //2жϷ,лسеĲſɽ
{
	u8 Res;
#ifdef OS_TICKS_PER_SEC	 
	OSIntEnter();    
#endif
	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET) 
		{
		Res =USART_ReceiveData(USART2);
		
		if((USART_RX_STA&0x8000)==0)
			{
			if(USART_RX_STA&0x4000)
				{
				if(Res!=0x0a)USART_RX_STA=0;
				else USART_RX_STA|=0x8000;	
				}
			else
				{	
				if(Res==0x0d)USART_RX_STA|=0x4000;
				else
					{
					USART_RX_BUF[USART_RX_STA&0X3FFF]=Res ;
					USART_RX_STA++;
					if(USART_RX_STA>(USART_REC_LEN-1))USART_RX_STA=0;
					}		 
				}
			}   		 
     } 
#ifdef OS_TICKS_PER_SEC
	OSIntExit();  											 
#endif
} 
































