
#include "stm32f0xx.h"
#include "stm32f0xx_tim.h"
#include "stm32f0xx_rcc.h"
#include "usmart.h"
#include "system.h"
#include "timer.h"	      

u8 *sys_cmd_tab[]=
{
	"?",
	"help",
	"list",
	"id",
	"hex",
	"dec",	   
};	    
//ϵͳָ
//0,ɹ;,;
u8 usmart_sys_cmd_exe(u8 *str)
{
	u8 i;
	u8 sfname[MAX_FNAME_LEN];//űغ
	u8 pnum;
	u8 rval;
	u32 res;

	res=usmart_get_cmdname(str,sfname,&i,MAX_FNAME_LEN);//õָָ
	if(res)return USMART_FUNCERR;//ָ 
	str+=i;					 			    
	for(i=0;i<8;i++)//֧8ϵͳָ
	{
		if(usmart_strcmp(sfname,sys_cmd_tab[i])==0)break;
	}
	switch(i)
	{					   
		case 0:
		case 1://ָ
			printf("\r\n");
#if USMART_USE_HELP
			printf("------------------------USMART V2.8------------------------ \r\n");
			printf("    USMARTALIENTEKһɵĴڵԻ,ͨ \r\n");
			printf(",ֵͨóκκ,ִ.,\r\n");
			printf("ĺ(֧(10/16)ַ\r\n");	  
			printf("ڵַΪ),֧10,ֺ֧ \r\n");
			printf("ֵʾ.ʾù,ת.\r\n");
			printf("֧:www.openedv.com\r\n");
			printf("USMART6ϵͳ:\r\n");
			printf("?:    ȡϢ\r\n");
			printf("help: ȡϢ\r\n");
			printf("list: õĺб\r\n\n");
			printf("id:   úIDб\r\n\n");
			printf("hex:  16ʾ,ո+ִּнת\r\n\n");
			printf("dec:  10ʾ,ո+ִּнת\r\n\n");
			printf("밴ճдʽ뺯Իس.\r\n");    
			printf("--------------------------ALIENTEK------------------------- \r\n");
#else
			printf("ָʧЧ\r\n");
#endif
			break;
		case 2://ѯָ
			printf("\r\n");
			printf("-------------------------嵥--------------------------- \r\n");
			for(i=0;i<usmart_dev.fnum;i++)printf("%s\r\n",usmart_dev.funs[i].name);
			printf("\r\n");
			break;	 
		case 3://ѯID
			printf("\r\n");
			printf("------------------------- ID --------------------------- \r\n");
			for(i=0;i<usmart_dev.fnum;i++)
			{
				usmart_get_fname((u8*)usmart_dev.funs[i].name,sfname,&pnum,&rval);//õغ 
				printf("%s id is:\r\n0X%08X\r\n",sfname,usmart_dev.funs[i].func); //ʾID
			}
			printf("\r\n");
			break;
		case 4://hexָ
			printf("\r\n");
			usmart_get_aparm(str,sfname,&i);
			if(i==0)//
			{
				i=usmart_str2num(sfname,&res);	   	//¼ò	
				if(i==0)						  	//ת
				{
					printf("HEX:0X%X\r\n",res);	   	//תΪ16
				}else if(i!=4)return USMART_PARMERR;//.
				else 				   				//ʾ趨
				{
					printf("16Ʋʾ!\r\n");
					usmart_dev.sptype=SP_TYPE_HEX;  
				}

			}else return USMART_PARMERR;			//.
			printf("\r\n"); 
			break;
		case 5://decָ
			printf("\r\n");
			usmart_get_aparm(str,sfname,&i);
			if(i==0)//
			{
				i=usmart_str2num(sfname,&res);	   	//¼ò	
				if(i==0)						   	//ת
				{
					printf("DEC:%lu\r\n",res);	   	//תΪ10
				}else if(i!=4)return USMART_PARMERR;//.
				else 				   				//ʾ趨
				{
					printf("10Ʋʾ!\r\n");
					usmart_dev.sptype=SP_TYPE_DEC;  
				}

			}else return USMART_PARMERR;			//. 
			printf("\r\n"); 
			break;	 
		case 6://readָ
			printf("\r\n");
			usmart_get_aparm(str,sfname,&i);
			if(i==0)//
			{
				i=usmart_str2num(sfname,&res);	   		//¼ò	
				if(i==0)						   		//ȡַָݹ
				{
					if(usmart_dev.sptype==SP_TYPE_HEX)printf("*(0X%X)=0X%X\r\n",res,*(u32*)res);	//ȡֵַָ
					else printf("*(%d)=%d\r\n",res,*(u32*)res);	//ȡֵַָ
				}else return USMART_PARMERR;   			//δ,߲	 
 			}else return USMART_PARMERR;				//. 
			printf("\r\n"); 
			break;	    
		default://Ƿָ
			return USMART_FUNCERR;
	}
	return 0;
}
////////////////////////////////////////////////////////////////////////////////////////
//ʼڿ
void usmart_init(u8 sysclk)
{
#if USMART_ENTIM_SCAN==1
	TIM14_Init(1000,(u32)sysclk*100-1);//Ƶ,ʱΪ10K ,100msжһ
#endif
	usmart_dev.sptype=1;	//ʮʾ
}		
//strлȡ,id,Ϣ
//*str:ַָ.
//ֵ:0,ʶɹ;,.
u8 usmart_cmd_rec(u8*str) 
{
	u8 sta,i,rval;//״̬	 
	u8 rpnum,spnum;
	u8 rfname[MAX_FNAME_LEN];//ݴռ,ڴŽյĺ  
	u8 sfname[MAX_FNAME_LEN];//űغ
	sta=usmart_get_fname(str,rfname,&rpnum,&rval);//õյݵĺ	  
	if(sta)return sta;//
	for(i=0;i<usmart_dev.fnum;i++)
	{
		sta=usmart_get_fname((u8*)usmart_dev.funs[i].name,sfname,&spnum,&rval);//õغ
		if(sta)return sta;//ؽ	  
		if(usmart_strcmp(sfname,rfname)==0)//
		{
			if(spnum>rpnum)return USMART_PARMERR;//(Դ)
			usmart_dev.id=i;//¼ID.
			break;//.
		}	
	}
	if(i==usmart_dev.fnum)return USMART_NOFUNCFIND;	//δҵƥĺ
 	sta=usmart_get_fparam(str,&i);					//õ	
	if(sta)return sta;								//ش
	usmart_dev.pnum=i;								//¼
    return USMART_OK;
}
//usamrtִк
//úִдӴյЧ.
//֧10ĺ,Ĳ֧Ҳʵ.õĺ.һ5ҵĲĺѾټ.
//úڴڴӡִ.:"(12...N)=ֵ".ʽӡ.
//ִеĺûзֵʱ,ӡķֵһ.
void usmart_exe(void)
{
	u8 id,i;
	u32 res;		   
	u32 temp[MAX_PARM];//ת,ʹַ֧֮ 
	u8 sfname[MAX_FNAME_LEN];//űغ
	u8 pnum,rval;
	id=usmart_dev.id;
	if(id>=usmart_dev.fnum)return;//ִ.
	usmart_get_fname((u8*)usmart_dev.funs[id].name,sfname,&pnum,&rval);//õغ, 
	printf("\r\n%s(",sfname);//Ҫִеĺ
	for(i=0;i<pnum;i++)//
	{
		if(usmart_dev.parmtype&(1<<i))//ַ
		{
			printf("%c",'"');			 
			printf("%s",usmart_dev.parm+usmart_get_parmpos(i));
			printf("%c",'"');
			temp[i]=(u32)&(usmart_dev.parm[usmart_get_parmpos(i)]);
		}else						  //
		{
			temp[i]=*(u32*)(usmart_dev.parm+usmart_get_parmpos(i));
			if(usmart_dev.sptype==SP_TYPE_DEC)printf("%lu",temp[i]);//10Ʋʾ
			else printf("0X%X",temp[i]);//16Ʋʾ 	   
		}
		if(i!=pnum-1)printf(",");
	}
	printf(")");
	switch(usmart_dev.pnum)
	{
		case 0://޲(void)											  
			res=(*(u32(*)())usmart_dev.funs[id].func)();
			break;
	    case 1://1
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0]);
			break;
	    case 2://2
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1]);
			break;
	    case 3://3
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2]);
			break;
	    case 4://4
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3]);
			break;
	    case 5://5
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4]);
			break;
	    case 6://6
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4],\
			temp[5]);
			break;
	    case 7://7
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4],\
			temp[5],temp[6]);
			break;
	    case 8://8
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4],\
			temp[5],temp[6],temp[7]);
			break;
	    case 9://9
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4],\
			temp[5],temp[6],temp[7],temp[8]);
			break;
	    case 10://10
			res=(*(u32(*)())usmart_dev.funs[id].func)(temp[0],temp[1],temp[2],temp[3],temp[4],\
			temp[5],temp[6],temp[7],temp[8],temp[9]);
			break;
	}
	if(rval==1)//Ҫֵ.
	{
		if(usmart_dev.sptype==SP_TYPE_DEC)printf("=%lu;\r\n",res);//ִн(10Ʋʾ)
		else printf("=0X%X;\r\n",res);//ִн(16Ʋʾ)	   
	}else printf(";\r\n");//Ҫֵ,ֱ
	
}
//usmartɨ躯
//ͨøú,ʵusmartĸ.úҪÿһʱ䱻һ
//ԼʱִдӴڷĸ.
//ж,ӶʵԶ.
//ALIENTEKû,USART_RX_STAUSART_RX_BUF[]ҪûԼʵ
void usmart_scan(void)
{
	u8 sta,len;
	if(USART_RX_STA&0x8000)//ڽɣ
	{					   
		len=USART_RX_STA&0x3fff;	//õ˴νյݳ
		USART_RX_BUF[len]='\0';	//ĩβ. 
		sta=usmart_dev.cmd_rec(USART_RX_BUF);//õϢ
		if(sta==0)usmart_dev.exe();//ִк
		else 
		{  
			len=usmart_sys_cmd_exe(USART_RX_BUF);
			if(len!=USMART_FUNCERR)sta=len;
			if(sta)
			{
				switch(sta)
				{
					case USMART_FUNCERR:
						printf("!\r\n");   			
						break;	
					case USMART_PARMERR:
						printf("!\r\n");   			
						break;				
					case USMART_PARMOVER:
						printf("̫!\r\n");   			
						break;		
					case USMART_NOFUNCFIND:
						printf("δҵƥĺ!\r\n");   			
						break;		
				}
			}
		}
		USART_RX_STA=0;//״̬Ĵ	    
	}
}

#if USMART_USE_WRFUNS==1 	//ʹ˶д
//ȡֵַָ		 
u32 read_addr(u32 addr)
{
	return *(u32*)addr;//	
}
//ַָдֵָ		 
void write_addr(u32 addr,u32 val)
{
	*(u32*)addr=val; 	
}
#endif













